/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_MOVETOOL_H
#define GRAPHIC_MOVETOOL_H

#include "tool.h"

class Dialog;
class Graphic;
class Line;
class Menu;
class PopupWindow;
class SlidingLine;
class SlidingRect;
class Transformer;
class Window;

class MoveTool: public Tool
{
	public:
		MoveTool(GraphicMaster *);
		virtual ~MoveTool();

		virtual boolean grasp(const Event &);
		virtual boolean manipulating(const Event &);
		virtual boolean effect(const Event &);

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		Transformer *erase_slrect();
	private:
		Coord _rx,_ry;
		SlidingRect *_slr;
		boolean _growing;
};

#endif
