/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_POLYGRAPHIC_H
#define GRAPHIC_POLYGRAPHIC_H

#include "graphic.h"

class GlyphViewer;
class PolyGlyph;

class PolyGraphic: public Graphic
{
	public:
		PolyGraphic(Graphic * = nil) ;
		virtual ~PolyGraphic();
		virtual void request(Requisition &) const;
		virtual void allocate(Canvas *,const Allocation &,Extension &);

		virtual void undraw();

		virtual void append_(Graphic *);
		virtual void prepend_(Graphic *);
		virtual void insert_(GlyphIndex,Graphic *);
		virtual void remove_(GlyphIndex);
		virtual void replace_(GlyphIndex,Graphic *);
		virtual void change_(GlyphIndex);

		virtual GlyphIndex count_() const;
		virtual Graphic* component_(GlyphIndex) const;

		virtual void modified_(GlyphIndex);
		virtual void flush();
		virtual Glyph *clone() const;

		virtual Graphic *first_containing(PointObj &);
		virtual Graphic *last_containing(PointObj &);

		virtual Graphic *first_intersecting(BoxObj &);
		virtual Graphic *last_intersecting(BoxObj &);

		virtual Graphic *first_within(BoxObj &);
		virtual Graphic *last_within(BoxObj &);

		virtual void disconnect_all();
		//virtual void update(GlyphViewer * = nil);

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		virtual void draw_gs(Canvas *,Graphic *);
		virtual void drawclipped_gs(Canvas *,Coord,Coord,Coord,Coord,Graphic *);
		virtual boolean contains_gs(PointObj &,Graphic *);
		virtual boolean intersects_gs(BoxObj &,Graphic *);
		virtual void getextent_gs(Coord &,Coord &,Coord &,Coord &,float &,Graphic *);
	
	protected:
		PolyGlyph *_body;
};

#endif
