/*
Copyright (c) 1993, Clemens Wagner
 
Permission to use, copy, modify, and distribute this software and 
its documentation for any purpose is hereby granted without fee, provided
that
(i) you have alays to distribute the whole archive
(ii) the above copyright notices and this permission notice appear in
all copies of the software and related documentation, changed or new
code has to be marked
(iii) else, there are the same conditions as for InterViews

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 */

#ifndef GRAPHIC_TEXT_H
#define GRAPHIC_TEXT_H

#include "graphic.h"

class String;

class Text: public Graphic
{
	public:
		Text (const Font *font,const Color *stroke,const char *,Transformer * =nil);
		virtual void text(const char *);
		virtual const char *text();
		virtual void draw(Canvas *,const Allocation &) const;
		virtual void request(Requisition &) const;
		virtual void allocate(Canvas *,const Allocation &,Extension &);
		virtual Glyph* clone() const;

		virtual ClassId get_classid() const;
		virtual boolean is_a(ClassId) const;
	protected:
		virtual ~Text();
		
		virtual void getextent_gs(Coord &,Coord &,Coord &,Coord &,float &,Graphic*);
		virtual void draw_gs(Canvas *,Graphic *);

		void compute_metrics();
	private:
		Coord _ascent,_descent;
		Coord _left,_right,_width;
		Coord *_char_widths;
		String *_text;
		Allocation _a;
};

#endif
